/*
 *  Copyright (C) 2013  Thadeu Lima de Souza Cascardo <cascardo@cascardo.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <sgp/group.h>
#include <sgp/friend.h>
#include <stdlib.h>

struct sgp_group {
	struct sgp_friend **friends;
	int nr_friends;
};

struct sgp_group * sgp_group_new()
{
	struct sgp_group *group;
	group = malloc(sizeof(*group));
	group->nr_friends = 0;
	group->friends = NULL;
	return group;
}

int sgp_group_add_friend(struct sgp_group *group, struct sgp_friend *friend)
{
	return 0;
}

/*
 * Get the channel used for communication with a friend.
 */
struct sgp_friend ** sgp_group_first(struct sgp_group *group)
{
	if (group->nr_friends > 0)
		return &group->friends[0];
	return NULL;
}

struct sgp_friend ** sgp_group_next(struct sgp_group *group,
					struct sgp_friend **friend)
{
	int n;
	n = (friend - group->friends) / sizeof(*friend);
	if (group->nr_friends > n + 1)
		return &group->friends[n+1];
	return NULL;
}
