/*
 *  Copyright (C) 2013  Thadeu Lima de Souza Cascardo <cascardo@cascardo.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <sgp/share.h>
#include <sgp/group.h>
#include <sgp/friend.h>
#include <sgp/msg.h>
#include <sgp/send.h>

/*
 * Share message with a group of friends.
 */
int sgp_share(struct sgp_group *group, struct sgp_msg *msg)
{
	struct sgp_friend *friend;
	struct sgp_friend **pfriend;
	sgp_foreach_friend(group, friend, pfriend) {
		/*
		 * TODO: mark message as sent if successfully sent and
		 * queue for another try if it was not possible.
		 */
		sgp_send(friend, msg);
	}
	return 0;
}
